/**
 * Created with IntelliJ IDEA.
 * @author: jozhua@live.cn
 * @date: 2017/6/2
 * To change this template use File | Settings | File Templates.
 */
import Loader from './loader';
function addEventListener(element, type, handler) {
    if (element.addEventListener) element.addEventListener(type, handler, false);
}

function APP(config) {
    let app = {}, w = window, doc = document,loader, body = doc.body,  encode = encodeURIComponent, json2str = JSON.stringify, platform = body.getAttribute("data-platform"), appVersion = +body.getAttribute('data-appVersion'), appFat = config || {}, appMode = appVersion > 0 && appFat['appMode'] ? appFat['appMode'] : 0;

    function bindState(url) {
        hideLoading();
        setTimeout(function () {
            if (url === 'back') history.back();
            else location.assign(url);
        }, 500);
    }

    function createLoading() {
        loader = new Loader(appFat);
        return loader.open();
    }

    function hideLoading() {
        loader && loader.close();
    }

    function initAllNode(list) {
        for (let i = 0, el; el = list[i]; i++) {
            let node = el, method = node.getAttribute('data-method'), parameter = node.getAttribute('data-parameter');
            if (!method) continue;
            if (parameter == null || parameter == "null") parameter = "";
            if (method === 'go') {
                let url = node.getAttribute('data-href');
                if (url) addEventListener(node, 'click', function (e) {
                    if (url == 'back2app') return back2app();
                    createLoading();
                    setTimeout(function () {
                        bindState(url);
                    }, 500);
                    e.preventDefault();
                }, false);
                continue;
            }
            if (appMode) {
                try {
                    parameter = JSON.parse(parameter);
                } catch (e) {
                    parameter = parameter || {};
                }
                let mode = json2str({mode: method, data: parameter});
                mode = platform == 'ios' ? [appMode, '://', encode(mode)] : ['javascript:', appFat['android'], '.', appMode, '(\'' + mode + '\')'];
                node.setAttribute('href', mode.join(''));
                continue;
            }
            if (platform == 'ios') {
                node.setAttribute('href', method + '://' + encode(parameter))
            } else if (platform == 'android') {
                method = method == 'sharewechat' ? 'sharewechat1' : method;
                if (parameter) parameter = '\'' + parameter + '\'';
                node.setAttribute('href', 'javascript:' + appFat[platform] + '.' + method + (parameter ? '(' + parameter + ')' : '()'));
            }
            node.removeAttribute('data-method');
            node.removeAttribute('data-parameter');
        }
    }

    function initDoc(el) {
        if (platform != '' && platform != 'null') initAllNode(doc.querySelectorAll(el));
    }


    function callAppMethod(method) {
        if (!method) return;
        let parameter = arguments[1] || '';
        if (appMode) {
            try {
                var mode = json2str({mode: method, data: parameter || {}});
                platform == 'android' ? w[appFat['android']][appMode](mode) : (doc.location = [appMode, '://', mode].join(''));
                return;
            } catch (n) {
                console.log('>>>82:~~app:' + method + '(' + parameter + ')~~>' + n);
            }
        }
        if (typeof parameter == 'object') parameter = json2str(parameter);
        if (platform == "ios") {
            doc.location = method + "://" + encode(parameter);
        }
        else if (platform == "android") {
            method = method == 'sharewechat' ? 'sharewechat1' : method;
            setTimeout(function () {
                try {
                    var plat = w[appFat[platform]];
                    parameter ? plat[method]("" + parameter) : plat[method]();
                } catch (n) {
                    doc.location = appFat[platform + 'BackWap'] + '/' + encode(parameter);
                }
            }, 20)
        }

    }

    function back2app() {
        createLoading();
        e();
        function e() {
            setTimeout(function () {
                var a = new Date(), t;
                try {
                    if (appMode) {
                        var mode = json2str({mode: "back", data: {}});
                        platform == "android" ? w[appFat['android']][appMode](mode) : (doc.location = [appMode, '://', mode].join(''));
                    } else {
                        t = appFat[platform + 'Back'];
                        platform == "android" ? w[appFat[platform]][t]() : (doc.location = appFat[platform + 'BackWap']);
                    }
                } catch (e) {
                    console.log('>>>129:~app:back2app~~~~~~~>' + e);
                } finally {
                    setTimeout(function () {
                        t = platform == "ios" ? appFat[platform + 'Back'] : appFat[platform + 'BackWap'];
                        doc.location = t;
                    }, 20);
                    if (new Date() - a < 4) setTimeout(hideLoading, 1e3);
                }
            }, 50);
        }
    }
    if (!w.appInited) {
        w.appInited = !0;
        initDoc('a[data-method]');
        addEventListener(w, 'pageshow', function (e) {
            if (e['persisted']) {
                hideLoading();
            }
        });
    }
    app.callApp = callAppMethod;
    app.gotoApp = back2app;
    return app;
}

export default APP;