/**
 * Created with WebStorm.
 * @author: jozhua@live.cn
 * @date: 2017/8/1
 * To change this template use File | Settings | File Templates.
 */
import cp from './els';

let classCache = {}, classList;
function className(node, value) {
    var klass = node.className;
    if (value === undefined) return klass;
    node.className = value
}

function classRE(name) {
    return name in classCache ?
        classCache[name] : (classCache[name] = new RegExp('(^|\\s)' + name + '(\\s|$)'))
}
cp.extend(cp.fn, {
    hasClass: function (name) {
        return [].some.call(this, function (el) {
            return this.test(className(el))
        }, classRE(name));
    },
    addClass(name){
        return this.each(function () {
            classList = []
            let cls = className(this);
            name.split(/\s+/g).forEach(function (klass) {
                let classRe = classRE(klass);
                if (!classRe.test(cls)) classList.push(klass);
            }, this);
            classList.length && className(this, cls + (cls ? " " : "") + classList.join(" "))
        })
    },
    removeClass(name){
        return this.each(function () {
            if (name === undefined) return className(this, '');
            classList = className(this);
            name.split(/\s+/g).forEach(function (klass) {
                classList = classList.replace(classRE(klass), " ");
            });
            className(this, classList.trim());
        })
    }
})