/**
 * Created with WebStorm.
 * @author: jozhua@live.cn
 * @date: 2017/7/10
 * To change this template use File | Settings | File Templates.
 */
import cp from "./els";
let prefix = '', eventPrefix, vendors = {Webkit: 'webkit', Moz: '', O: 'o'}, testEl = document.createElement('div');

function normalizeEvent(name) {
    return eventPrefix ? eventPrefix + name : name.toLowerCase()
}

if (testEl.style.transform === undefined) cp.each(vendors, function (vendor, event) {
    if (testEl.style[vendor + 'TransitionProperty'] !== undefined) {
        prefix = '-' + vendor.toLowerCase() + '-';
        eventPrefix = event;
        return false
    }
})


cp.fx = {
    off: (eventPrefix === undefined && testEl.style.transitionProperty === undefined),
    cssPrefix: prefix,
    transitionEnd: normalizeEvent('TransitionEnd'),
    animationEnd: normalizeEvent('AnimationEnd')
}

cp.fn.transitionEnd = function (callback) {
    let that = this, endEvent = cp.fx.transitionEnd + " transitionend";

    function fireCallBack(e) {
        /*jshint validthis:true */
        if (e.target !== this) return;
        callback.call(this, e);
        that.off(endEvent, fireCallBack);
    }

    if (callback) {
        that.on(endEvent, fireCallBack);
    }
    return this;
};
cp.fn.animationEnd = function (callback) {
    let that = this, endEvent = cp.fx.animationEnd + " animationend";

    function fireCallBack(e) {
        callback(e);
        that.off(endEvent, fireCallBack);
    }

    if (callback) {
        that.on(endEvent, fireCallBack);
    }
    return this;
};
testEl = null;
