import "./fix";
import "./toggle";
import  style from "./stylesheets";
import cp from "./els";

var $ = cp.el, transform = cp.fx.cssPrefix + 'transform', transitionEnd = cp.fx.transitionEnd + ' transitionend';
var initCss = !1, panelCssStr = '.with-panel-left-over,.with-panel-right-over,.with-panel-right-push,.with-panel-left-push{overflow:hidden}.panel-overlay{position:absolute;left:0;top:0;width:100%;height:100%;background:transparent;opacity:0;z-index:5000;display:none}body.with-panel-left-over .panel-overlay,body.with-panel-right-over .panel-overlay{display:block}.panel{z-index:1000;background:#fff;-webkit-box-sizing:border-box;box-sizing:border-box;overflow:auto;-webkit-overflow-scrolling:touch;position:absolute;width:260px;top:0;height:100%;display:none}.panel.panel-over,.panel.panel-push,.panel-push-cont{-webkit-transform:translate3d(0, 0, 0);transform:translate3d(0, 0, 0);-webkit-transition-duration:400ms;transition-duration:400ms;-webkit-transition-property:-webkit-transform, opacity;opacity;transition-property:transform, opacity}.panel.panel-left{z-index:10700}.panel.panel-left.panel-push{left:0}.panel.panel-right{z-index:10700}.panel.panel-right.panel-push{right:0}body.with-panel-left-over .panel-overlay,body.with-panel-right-over .panel-overlay{display:block}body.with-panel-left-push .panel-overlay,body.with-panel-right-push .panel-overlay{display:block}.popup{position:absolute;left:0;top:0;width:100%;height:100%;z-index:10700;background:#fff;-webkit-box-sizing:border-box;box-sizing:border-box;display:none;overflow:auto;-webkit-overflow-scrolling:touch;-webkit-transition-property:-webkit-transform;transition-property:transform;-webkit-transform:translate3d(0, 100%, 0);transform:translate3d(0, 100%, 0)}.popup.popdown{-webkit-transform:translate3d(0, -100%, 0);transform:translate3d(0, -100%, 0)}.popup.modal-in,.popup.modal-out{-webkit-transition-duration:400ms;transition-duration:400ms}.popup.modal-in{-webkit-transform:translate3d(0, 0, 0);transform:translate3d(0, 0, 0)}.popup.modal-out{-webkit-transform:translate3d(0, 100%, 0);transform:translate3d(0, 100%, 0)}.popup.popdown.modal-out{-webkit-transform:translate3d(0, -100%, 0);transform:translate3d(0, -100%, 0)}.page-view{position:relative;width:100%;height:100%;z-index:5000;overflow:hidden;-webkit-box-sizing:border-box;box-sizing:border-box}.page-view .navbar{position:relative}.page-view .navbar-inner{background:#1e1e1e;color:#FFF}.page-view .navbar-inner a{color:#FFF}';
function importStyle(e) {
    var div = document.createElement('div'), body = document.body, currentStyle;
    div.className = 'panel';
    body.appendChild(div);
    setTimeout(function () {
        currentStyle = style.getCurrentStyle(div);
        if (currentStyle.display != 'none' || currentStyle.position != 'absolute') style.importStyle(e);
        body.removeChild(div);
    }, 20)
}
function Panel(el, options) {
    var defaultOptions = {
        targetContent: '',
        displayMode: 'over',
        direction: 'left',
        overlay: true,
        src: '',
    }
    if (!el || el.nodeType !== 1) return;
    //扩展options
    this.options = cp.extend(defaultOptions, options);
    //Panel对象
    var $el = $(this.el);
    //Content对象
    this.cont = this.options.targetContent;
    if (this.options.direction == 'right' || this.options.direction == 'left') el.style[this.options.direction] = '-100000px';
    //Panel宽度
    var width = el.clientWidth;
    this.width = (width === 0 ? window.innerWidth : width);
    this.winWidth = document.documentElement.clientWidth;
    this.$el = $el;
    this.el = el;
    this.isOpen = false;     //Panel打开状态，默认为false(关闭)
    if (!initCss) {
        importStyle(panelCssStr);
        initCss = !0;
    }
    this.init();
}
//初始化Panel
Panel.prototype.init = function () {
    var _ts = this, _opts = _ts.options, $body = $('body');
    //触发页面reflow
    this.el.clientLeft;
    if (_opts.direction == 'bottom' || _opts.direction == 'top') {
        _opts.displayMode = 'over';
        if (_opts.direction == 'top') this.$el.addClass('popup popdown');
    }
    else {
        this.$el.addClass('panel panel-' + _opts.direction + ' panel-' + _opts.displayMode).get(0).style.display = 'none';
    }
    if (_opts.overlay) this.$overplay = this._getOverlay();
    else this.$overplay = $();
    $body.on(cp.support.touch ? 'touchstart' : 'mousedown', '.modal-overlay,.panel-overlay, .close-popup', function () {
        if (_ts.isOpen && $('body').hasClass('with-panel-' + _opts.direction + '-' + _opts.displayMode)) {
            if ($(this).hasClass('close-popup')) _ts.close();
            else if (_opts.overlay) _ts.close();
        }
    });
    this.$el.on(transitionEnd, function () {
        if (_opts.src) {
            var frame = document.createElement('iframe');
            frame.frameborder = '0';
            frame.scrolling = 'no';
            frame.onload = function () {
                try {
                    var doc = this.contentDocument || this.contentWindow.document;
                    frame.style.height = doc.body.clientHeight + 'px';
                } catch (e) {
                }
                frame.onload = null;
            };
            frame.src = _opts.src;
            _opts.src = '';
            var pages = this.$el.find('.page-content')[0];
            pages.style.overflow = 'hidden';
            pages.innerHTML = '';
            pages.appendChild(frame);
        }
        $body.style.width = _ts.isOpen ? (_ts.winWidth + 'px') : 'auto';
        _opts.callback.call(_ts);
        return false;
    })
};
Panel.prototype._getOverlay = function () {
    var $overplay = $('.modal-overlay');
    if (!$overplay.length) {
        var div = document.createElement('div');
        div.className = 'modal-overlay';
        document.body.appendChild(div);
        $overplay = $(div);
    }
    return $overplay;
}
Panel.prototype.controlPanel = function (status) {
    var _ts = this,
        _opts = _ts.options;
    if (_opts.direction == 'top' || _opts.direction == 'bottom') return _ts.controlVerticalPanel(status);
    var _pos = _ts.getPosition()[_opts.displayMode];
    if (status) {
        $(_ts.cont).addClass('panel-push-cont');
        $('body').addClass('with-panel-' + _opts.direction + '-' + _opts.displayMode);
        this.el.style[_opts.direction] = -_ts.width + 'px';
        setTimeout(function () {
            _ts.$el.hide()
        }, 10);
        $(_ts.cont).transitionEnd(function () {
            this.style.display = 'none';
        });
    }
    else {
        this.$el.transitionEnd(function () {
            this.style.display = 'none';
            $(_ts.cont).addClass('panel-push-cont');
            $('body').removeClass('with-panel-' + _opts.direction + '-' + _opts.displayMode);
        });
        $(_ts.cont).show();
    }
    setTimeout(function () {
        _ts.el.style[transform] = 'translate3d(' + _ts.transDirectionToPos(_opts.direction, _pos.panel[Number(status)]) + 'px,0,0)';
        _ts.cont.style[transform] = 'translate3d(' + _ts.transDirectionToPos(_opts.direction, _pos.cont[Number(status)]) + 'px,0,0)';
    }, 50);
    _ts.isOpen = !_ts.isOpen;
}

Panel.prototype.controlVerticalPanel = function (status) {
    var _ts = this, $el = $(_ts.el), _opts = _ts.options;
    if (status) {
        _ts.$overplay.addClass('modal-overlay-visible');
        $el.addClass('modal-out').show()
        setTimeout(function () {
            $el.removeClass('modal-out').addClass('modal-in');
        }, 20);
        $('body').addClass('with-panel-' + _opts.direction + '-' + _opts.displayMode);
    }
    else {
        _ts.$overplay.removeClass('modal-overlay-visible');
        $el.removeClass('modal-in').addClass('modal-out');
        $el.transitionEnd(function () {
            $(this).removeClass('modal-out').hide();
            $('body').addClass('with-panel-' + _opts.direction + '-' + _opts.displayMode);
        });
    }
    _ts.isOpen = !_ts.isOpen;
};
Panel.prototype.transDirectionToPos = function (direct, val) {
    return direct === 'left' ? val : -val;
}

Panel.prototype.getPosition = function () {
    var _ts = this,
        _width = _ts.width;
    return {
        push: {
            panel: [0, _width],
            cont: [0, _width]
        },
        over: {
            panel: [0, _width],
            cont: [0, 0]
        }
    }
}

//打开Panel
Panel.prototype.open = function () {
    return this.controlPanel(true);
}

//关闭Panel
Panel.prototype.close = function () {
    return this.controlPanel(false);
}

//切换Panel的打开或关闭状态
Panel.prototype.toggle = function () {
    return this[this.isOpen ? 'close' : 'open']();
}
export default  Panel;