/**
 * Created with IntelliJ IDEA.
 * @author: jozhua@live.cn
 * @date: 2017/6/2
 * To change this template use File | Settings | File Templates.
 */
import cp from './els';
let touch = {}, tapTimeout;

function isPointerEventType(e, type) {
    return (e.type == 'pointer' + type || e.type.toLowerCase() == 'mspointer' + type)
}

function isPrimaryTouch(event) {
    return (event.pointerType == 'touch' || event.pointerType == event.MSPOINTER_TYPE_TOUCH) && event.isPrimary
}

cp.ready( function () {
    var now, delta, deltaX = 0, deltaY = 0, firstTouch, _isPointerType, gesture;

    if ('MSGesture' in global) {
        gesture = new MSGesture();
        gesture.target = document.body;
    }
    var TOUCHSTART = 'pointerdown', TOUCHMOVE = 'pointermove', TOUCHEND = 'pointerup', TOUCHCANCEL = 'pointercancel';
    if ('onmspointerdown' in global) {
        TOUCHSTART = 'MSPointerDown';
        TOUCHMOVE = 'MSPointerMove';
        TOUCHEND = 'MSPointerUp';
        TOUCHCANCEL = 'MSPointerCancel';
    }
    else if ('ontouchstart' in global) {
        TOUCHSTART = 'touchstart';
        TOUCHMOVE = 'touchmove';
        TOUCHEND = 'touchend';
        TOUCHCANCEL = 'touchcancel';
    }
    function cancelAll() {
        if (tapTimeout) clearTimeout(tapTimeout);
        tapTimeout = null;
        touch = {};
    }

    cp.el(document).on(TOUCHSTART, function (e) {
        if ((_isPointerType = isPointerEventType(e, 'down')) && !isPrimaryTouch(e)) return
        firstTouch = _isPointerType ? e : e.touches[0];
        if (e.touches && e.touches.length === 1 && touch.x2) {
            // Clear out touch movement data if we have it sticking around
            // This can occur if touchcancel doesn't fire due to preventDefault, etc.
            touch.x2 = undefined;
            touch.y2 = undefined;
        }
        now = Date.now();
        delta = now - (touch.last || now);
        touch.el = 'tagName' in firstTouch.target ? firstTouch.target : firstTouch.target.parentNode;
        touch.x1 = firstTouch.pageX;
        touch.y1 = firstTouch.pageY;
        if (delta > 0 && delta <= 250) touch.isDoubleTap = true;
        touch.last = now;
        // adds the current touch contact for IE gesture recognition
        if (gesture && _isPointerType) gesture.addPointer(e.pointerId);
    });
    cp.el(document).on(TOUCHMOVE, function (e) {
        if ((_isPointerType = isPointerEventType(e, 'move')) && !isPrimaryTouch(e)) return;
        firstTouch = _isPointerType ? e : e.touches[0];
        touch.x2 = firstTouch.pageX;
        touch.y2 = firstTouch.pageY;

        deltaX += Math.abs(touch.x1 - touch.x2);
        deltaY += Math.abs(touch.y1 - touch.y2);
    });
    cp.el(document).on(TOUCHEND, function (e) {
        if ((_isPointerType = isPointerEventType(e, 'up')) && !isPrimaryTouch(e)) return;
        if ('last' in touch)
            if (deltaX < 30 && deltaY < 30) {
                // delay by one tick so we can cancel the 'tap' event if 'scroll' fires
                // ('tap' fires before 'scroll')
                tapTimeout = setTimeout(function () {
                    var event = cp.events('tap');
                    event.cancelTouch = cancelAll;
                    if (touch.el) cp.el(touch.el).trigger(event);
                }, 0)
            } else touch = {};
        deltaX = deltaY = 0;
    });
    cp.el(document).on(TOUCHCANCEL, cancelAll);
    cp.el(window).on( 'scroll', cancelAll)
})